/* Generated by wayland-scanner 1.20.0 */

#ifndef WEBOS_SYSTEM_UX_CLIENT_PROTOCOL_H
#define WEBOS_SYSTEM_UX_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_webos_system_ux The webos_system_ux protocol
 * @section page_ifaces_webos_system_ux Interfaces
 * - @subpage page_iface_wl_webos_system_ux - api to open sustem ui apps
 * @section page_copyright_webos_system_ux Copyright
 * <pre>
 *
 * Copyright (c) 2023 LG Electronics, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * </pre>
 */
struct wl_webos_system_ux;

#ifndef WL_WEBOS_SYSTEM_UX_INTERFACE
#define WL_WEBOS_SYSTEM_UX_INTERFACE
/**
 * @page page_iface_wl_webos_system_ux wl_webos_system_ux
 * @section page_iface_wl_webos_system_ux_desc Description
 * @section page_iface_wl_webos_system_ux_api API
 * See @ref iface_wl_webos_system_ux.
 */
/**
 * @defgroup iface_wl_webos_system_ux The wl_webos_system_ux interface
 */
extern const struct wl_interface wl_webos_system_ux_interface;
#endif

/**
 * @ingroup iface_wl_webos_system_ux
 * @struct wl_webos_system_ux_listener
 */
struct wl_webos_system_ux_listener {
	/**
	 * open system ux
	 *
	 * 
	 * @param app name of system ux app
	 * @param windowType name of system ux window type
	 * @param params parameter of system ux app
	 */
	void (*open)(void *data,
		     struct wl_webos_system_ux *wl_webos_system_ux,
		     const char *app,
		     const char *windowType,
		     const char *params);
	/**
	 * close system ux
	 *
	 * 
	 * @param app name of system ux app
	 */
	void (*close)(void *data,
		      struct wl_webos_system_ux *wl_webos_system_ux,
		      const char *app);
	/**
	 * notify general event to system ux app
	 *
	 * 
	 * @param action name of event action
	 * @param windowType name of system ux window type
	 * @param params event data of system ux app
	 */
	void (*notify)(void *data,
		       struct wl_webos_system_ux *wl_webos_system_ux,
		       const char *action,
		       const char *windowType,
		       const char *params);
};

/**
 * @ingroup iface_wl_webos_system_ux
 */
static inline int
wl_webos_system_ux_add_listener(struct wl_webos_system_ux *wl_webos_system_ux,
				const struct wl_webos_system_ux_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) wl_webos_system_ux,
				     (void (**)(void)) listener, data);
}

#define WL_WEBOS_SYSTEM_UX_OPENED 0
#define WL_WEBOS_SYSTEM_UX_CLOSED 1
#define WL_WEBOS_SYSTEM_UX_REQUEST_FOCUS 2
#define WL_WEBOS_SYSTEM_UX_RELEASE_FOCUS 3
#define WL_WEBOS_SYSTEM_UX_INVOKE 4

/**
 * @ingroup iface_wl_webos_system_ux
 */
#define WL_WEBOS_SYSTEM_UX_OPEN_SINCE_VERSION 1
/**
 * @ingroup iface_wl_webos_system_ux
 */
#define WL_WEBOS_SYSTEM_UX_CLOSE_SINCE_VERSION 1
/**
 * @ingroup iface_wl_webos_system_ux
 */
#define WL_WEBOS_SYSTEM_UX_NOTIFY_SINCE_VERSION 1

/**
 * @ingroup iface_wl_webos_system_ux
 */
#define WL_WEBOS_SYSTEM_UX_OPENED_SINCE_VERSION 1
/**
 * @ingroup iface_wl_webos_system_ux
 */
#define WL_WEBOS_SYSTEM_UX_CLOSED_SINCE_VERSION 1
/**
 * @ingroup iface_wl_webos_system_ux
 */
#define WL_WEBOS_SYSTEM_UX_REQUEST_FOCUS_SINCE_VERSION 1
/**
 * @ingroup iface_wl_webos_system_ux
 */
#define WL_WEBOS_SYSTEM_UX_RELEASE_FOCUS_SINCE_VERSION 1
/**
 * @ingroup iface_wl_webos_system_ux
 */
#define WL_WEBOS_SYSTEM_UX_INVOKE_SINCE_VERSION 1

/** @ingroup iface_wl_webos_system_ux */
static inline void
wl_webos_system_ux_set_user_data(struct wl_webos_system_ux *wl_webos_system_ux, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) wl_webos_system_ux, user_data);
}

/** @ingroup iface_wl_webos_system_ux */
static inline void *
wl_webos_system_ux_get_user_data(struct wl_webos_system_ux *wl_webos_system_ux)
{
	return wl_proxy_get_user_data((struct wl_proxy *) wl_webos_system_ux);
}

static inline uint32_t
wl_webos_system_ux_get_version(struct wl_webos_system_ux *wl_webos_system_ux)
{
	return wl_proxy_get_version((struct wl_proxy *) wl_webos_system_ux);
}

/** @ingroup iface_wl_webos_system_ux */
static inline void
wl_webos_system_ux_destroy(struct wl_webos_system_ux *wl_webos_system_ux)
{
	wl_proxy_destroy((struct wl_proxy *) wl_webos_system_ux);
}

/**
 * @ingroup iface_wl_webos_system_ux
 */
static inline void
wl_webos_system_ux_opened(struct wl_webos_system_ux *wl_webos_system_ux, const char *app)
{
	wl_proxy_marshal_flags((struct wl_proxy *) wl_webos_system_ux,
			 WL_WEBOS_SYSTEM_UX_OPENED, NULL, wl_proxy_get_version((struct wl_proxy *) wl_webos_system_ux), 0, app);
}

/**
 * @ingroup iface_wl_webos_system_ux
 */
static inline void
wl_webos_system_ux_closed(struct wl_webos_system_ux *wl_webos_system_ux, const char *app)
{
	wl_proxy_marshal_flags((struct wl_proxy *) wl_webos_system_ux,
			 WL_WEBOS_SYSTEM_UX_CLOSED, NULL, wl_proxy_get_version((struct wl_proxy *) wl_webos_system_ux), 0, app);
}

/**
 * @ingroup iface_wl_webos_system_ux
 */
static inline void
wl_webos_system_ux_request_focus(struct wl_webos_system_ux *wl_webos_system_ux, const char *name)
{
	wl_proxy_marshal_flags((struct wl_proxy *) wl_webos_system_ux,
			 WL_WEBOS_SYSTEM_UX_REQUEST_FOCUS, NULL, wl_proxy_get_version((struct wl_proxy *) wl_webos_system_ux), 0, name);
}

/**
 * @ingroup iface_wl_webos_system_ux
 */
static inline void
wl_webos_system_ux_release_focus(struct wl_webos_system_ux *wl_webos_system_ux, const char *name)
{
	wl_proxy_marshal_flags((struct wl_proxy *) wl_webos_system_ux,
			 WL_WEBOS_SYSTEM_UX_RELEASE_FOCUS, NULL, wl_proxy_get_version((struct wl_proxy *) wl_webos_system_ux), 0, name);
}

/**
 * @ingroup iface_wl_webos_system_ux
 */
static inline void
wl_webos_system_ux_invoke(struct wl_webos_system_ux *wl_webos_system_ux, const char *action, const char *windowType, const char *params)
{
	wl_proxy_marshal_flags((struct wl_proxy *) wl_webos_system_ux,
			 WL_WEBOS_SYSTEM_UX_INVOKE, NULL, wl_proxy_get_version((struct wl_proxy *) wl_webos_system_ux), 0, action, windowType, params);
}

#ifdef  __cplusplus
}
#endif

#endif
